panelapp/api/urls.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
from django.urls import path, include
from django.conf import settings
from drf_yasg.views import get_schema_view
from drf_yasg import openapi
from .permissions import ReadOnlyPermissions

schema_view = get_schema_view(
    openapi.Info(
        title="PanelApp API",
        default_version=settings.REST_FRAMEWORK["DEFAULT_VERSION"],
        description="PanelApp API",
        terms_of_service="https://panelapp.genomicsengland.co.uk/policies/terms/",
        contact=openapi.Contact(email="panelapp@genomicsengland.co.uk"),
        license=openapi.License(name="MIT License"),
    ),
    patterns=["api"],
    validators=["flex", "ssv"],
    public=True,
    permission_classes=(ReadOnlyPermissions,),
)

app_name = "api"
urlpatterns = [path("v1/", include("api.v1.urls", namespace="v1"))]

panelapp/panels/urls.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
from django.conf.urls import url

from django.views.generic import RedirectView
from .views import AdminView
from .views import AdminUploadGenesView
from .views import AdminUploadPanelsView
from .views import AdminUploadReviewsView
from .views import EntitiesListView
from .views import CreatePanelView
from .views import EntityDetailView
from .views import GenePanelView
from .views import PanelsIndexView
from .views import UpdatePanelView
from .views import PromotePanelView
from .views import PanelAddEntityView
from .views import PanelEditEntityView
from .views import PanelMarkNotReadyView
from .views import GenePanelSpanshotView
from .views import EntityReviewView
from .views import MarkEntityReadyView
from .views import DownloadPanelTSVView
from .views import DownloadPanelVersionTSVView
from .views import MarkGeneNotReadyView
from .views import ComparePanelsView
from .views import CompareGeneView
from .views import CopyReviewsView
from .views import DownloadAllGenes
from .views import DownloadAllPanels
from .views import ActivityListView
from .views import DownloadAllSTRs
from .views import DownloadAllRegions
from .views import GeneDetailRedirectView
from .views import RedirectGenesToEntities
from .views import OldCodeURLRedirect
from .ajax_views import ClearPublicationsAjaxView
from .ajax_views import ClearPhoenotypesAjaxView
from .ajax_views import ClearModeOfPathogenicityAjaxView
from .ajax_views import ClearSourcesAjaxView
from .ajax_views import ClearSingleSourceAjaxView
from .ajax_views import DeletePanelAjaxView
from .ajax_views import DeleteEntityAjaxView
from .ajax_views import RejectPanelAjaxView
from .ajax_views import ApprovePanelAjaxView
from .ajax_views import UpdateEntityTagsAjaxView
from .ajax_views import UpdateEntityMOPAjaxView
from .ajax_views import UpdateEntityMOIAjaxView
from .ajax_views import UpdateEntityPhenotypesAjaxView
from .ajax_views import UpdateEntityPublicationsAjaxView
from .ajax_views import UpdateEntityRatingAjaxView
from .ajax_views import DeleteEntityEvaluationAjaxView
from .ajax_views import GetEntityCommentFormAjaxView
from .ajax_views import DeleteEntityCommentAjaxView
from .ajax_views import SubmitEntityCommentFormAjaxView
from .ajax_views import ApproveEntityAjaxView


app_name = "panels"

entity_regex = "[\w\-\.\$\~\@\#\ ]+"
entity_types = "gene|str|region"

urlpatterns = [
    url(r"^$", PanelsIndexView.as_view(), name="index"),
    url(r"^compare/$", ComparePanelsView.as_view(), name="compare_panels_form"),
    url(
        r"^compare/(?P<panel_1_id>[0-9]+)/(?P<panel_2_id>[0-9]+)$",
        ComparePanelsView.as_view(),
        name="compare",
    ),
    url(
        r"^compare/(?P<panel_1_id>[0-9]+)/(?P<panel_2_id>[0-9]+)/(?P<gene_symbol>[\w\-]+)$",
        CompareGeneView.as_view(),
        name="compare_genes",
    ),
    url(
        r"^copy/(?P<panel_1_id>[0-9]+)/(?P<panel_2_id>[0-9]+)$",
        CopyReviewsView.as_view(),
        name="copy_reviews",
    ),
    url(r"^(?P<pk>[0-9]+)/$", GenePanelView.as_view(), name="detail"),
    url(r"^(?P<pk>[0-9]+)/update$", UpdatePanelView.as_view(), name="update"),
    url(r"^(?P<pk>[0-9]+)/promote$", PromotePanelView.as_view(), name="promote"),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/add".format(types=entity_types),
        PanelAddEntityView.as_view(),
        name="add_entity",
    ),
    url(r"^(?P<pk>[0-9]+)/delete$", DeletePanelAjaxView.as_view(), name="delete_panel"),
    url(r"^(?P<pk>[0-9]+)/reject$", RejectPanelAjaxView.as_view(), name="reject_panel"),
    url(
        r"^(?P<pk>[0-9]+)/approve$",
        ApprovePanelAjaxView.as_view(),
        name="approve_panel",
    ),
    url(
        r"^(?P<pk>[0-9]+)/download/(?P<categories>[0-4]+)/$",
        DownloadPanelTSVView.as_view(),
        name="download_panel_tsv",
    ),
    url(
        r"^(?P<pk>[0-9]+)/download_version/$",
        DownloadPanelVersionTSVView.as_view(),
        name="download_old_panel_tsv",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_name>{})/$".format(entity_regex),
        RedirectGenesToEntities.as_view(),
        name="redirect_previous_structure",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/$".format(
            types=entity_types, regex=entity_regex
        ),
        GenePanelSpanshotView.as_view(),
        name="evaluation",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/edit$".format(
            types=entity_types, regex=entity_regex
        ),
        PanelEditEntityView.as_view(),
        name="edit_entity",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/review$".format(
            types=entity_types, regex=entity_regex
        ),
        EntityReviewView.as_view(),
        name="review_entity",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/mark_as_ready$".format(
            types=entity_types, regex=entity_regex
        ),
        MarkEntityReadyView.as_view(),
        name="mark_entity_as_ready",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/mark_as_not_ready$".format(
            types=entity_types, regex=entity_regex
        ),
        MarkGeneNotReadyView.as_view(),
        name="mark_entity_as_not_ready",
    ),
    # AJAX endpoints
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/delete$".format(
            types=entity_types, regex=entity_regex
        ),
        DeleteEntityAjaxView.as_view(),
        name="delete_entity",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/approve$".format(
            types=entity_types, regex=entity_regex
        ),
        ApproveEntityAjaxView.as_view(),
        name="approve_entity",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/clear_entity_sources$".format(
            types=entity_types, regex=entity_regex
        ),
        ClearSourcesAjaxView.as_view(),
        name="clear_entity_sources",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/clear_entity_source/(?P<source>(.*))/$".format(
            types=entity_types, regex=entity_regex
        ),
        ClearSingleSourceAjaxView.as_view(),
        name="clear_entity_source",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/clear_entity_phenotypes$".format(
            types=entity_types, regex=entity_regex
        ),
        ClearPhoenotypesAjaxView.as_view(),
        name="clear_entity_phenotypes",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/clear_entity_publications$".format(
            types=entity_types, regex=entity_regex
        ),
        ClearPublicationsAjaxView.as_view(),
        name="clear_entity_publications",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/clear_entity_mode_of_pathogenicity$".format(
            types=entity_types, regex=entity_regex
        ),
        ClearModeOfPathogenicityAjaxView.as_view(),
        name="clear_entity_mode_of_pathogenicity",
    ),
    # AJAX Review endpoints
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_tags/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityTagsAjaxView.as_view(),
        name="update_entity_tags",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_rating/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityRatingAjaxView.as_view(),
        name="update_entity_rating",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_moi/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityMOIAjaxView.as_view(),
        name="update_entity_moi",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_mop/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityMOPAjaxView.as_view(),
        name="update_entity_mop",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_phenotypes/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityPhenotypesAjaxView.as_view(),
        name="update_entity_phenotypes",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_publications/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityPublicationsAjaxView.as_view(),
        name="update_entity_publications",
    ),
    url(

panelapp/panels/models/codes.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
"""Enums used in the app"""

from enum import Enum


class ProcessingRunCode(Enum):
    PROCESSED = 0
    PROCESS_BACKGROUND = 1

panelapp/panels/forms/activity.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
from django import forms


class ActivityFilterForm(forms.Form):
    panel = forms.ChoiceField(required=False, choices=list)
    version = forms.ChoiceField(required=False, choices=list)
    entity = forms.ChoiceField(
        label="Gene or Genomic Entity Name", required=False, choices=list
    )
    date_from = forms.DateField(
        required=False,
        widget=forms.DateInput(
            attrs={
                "type": "date",
                "placeholder": "Date in YYYY-MM-DD format",
                "pattern": "[0-9]{4}-[0-9]{2}-[0-9]{2}",
            }
        ),
    )
    date_to = forms.DateField(
        required=False,
        widget=forms.DateInput(
            attrs={
                "type": "date",
                "placeholder": "Date in YYYY-MM-DD format",
                "pattern": "[0-9]{4}-[0-9]{2}-[0-9]{2}",
            }
        ),
    )

    def __init__(self, *args, **kwargs):
        panels = kwargs.pop("panels")
        versions = kwargs.pop("versions")
        entities = kwargs.pop("entities")

        super().__init__(*args, **kwargs)

        self.fields["panel"].choices = [("", "Panel")] + list(panels)

        if versions:
            self.fields["version"].choices = [("", "Panel Version")] + list(versions)
        else:
            self.fields["version"].widget.attrs = {"disabled": "disabled"}

        if entities:
            self.fields["entity"].choices = [("", "")] + list(entities)
        else:
            self.fields["entity"].widget.attrs = {"disabled": "disabled"}

panelapp/panels/forms/geneready.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
from django import forms
from panels.models import GenePanelEntrySnapshot


class GeneReadyForm(forms.ModelForm):
    """
    This class marks Gene as Ready and also adds a comment if it was provided.
    It also saves a new evidence with the current Gene status as an evidence.
    Additionally, we add save a TrackRecord to note this change, and record an activity
    """

    ready_comment = forms.CharField(
        label="Comment (eg What decisions are being made?)",
        required=False,
        widget=forms.Textarea,
    )

    class Meta:
        model = GenePanelEntrySnapshot
        fields = ("comments",)

    def __init__(self, *args, **kwargs):
        self.request = kwargs.pop("request")
        super().__init__(*args, **kwargs)

        original_fields = self.fields
        self.fields = {}
        self.fields["ready_comment"] = original_fields.get("ready_comment")

    def save(self, *args, **kwargs):
        self.instance.mark_as_ready(
            self.request.user, self.cleaned_data["ready_comment"]
        )

panelapp/panels/templates/panels/entity/review/part_moi.html
{% load bootstrap3 %}
<div class="js-toggle-target">
    {{ entity.moi }}
    <a href="#" class="add-left-margin link-inherit js-toggle">Edit</a>
</div>
<form data-ajax-action="{% url 'panels:update_entity_moi' panel.panel_id entity_type entity_name %}" action="{% url 'panels:update_entity_moi' panel.panel_id entity_type entity_name %}#!review" method="post" class="form hide js-toggle-target">
    {% csrf_token %}
    {% for field in edit_entity_moi_form %}
      {{ field.label_tag }}
      <div class="add-label-margin">{% bootstrap_field field show_label=False %}</div>
      <span class="rm">{{ field.label_tag }}</span>
    {% endfor %}
    <input type="submit" class="btn btn-info" value="Update">
    <a href="#" class="add-left-margin btn btn-link js-toggle">Cancel</a>
</form>

panelapp/panels/templates/panels/entity/review/part_mop.html
{% load bootstrap3 %}
<div class="js-toggle-target">
    {{ entity.mode_of_pathogenicity }}
    <a href="#" class="add-left-margin link-inherit js-toggle">Edit</a>
</div>
<form data-ajax-action="{% url 'panels:update_entity_mop' panel.panel_id entity_type entity_name %}" action="{% url 'panels:update_entity_mop' panel.panel_id entity_type entity_name %}#!review" method="post" class="form hide js-toggle-target">
    {% csrf_token %}
    {% for field in edit_entity_mop_form %}
      {{ field.label_tag }}
      <div class="add-label-margin">{% bootstrap_field field show_label=False %}</div>
      <span class="rm">{{ field.label_tag }}</span>
    {% endfor %}
    <input type="submit" class="btn btn-info" value="Update">
    <a href="#" class="add-left-margin btn btn-link js-toggle">Cancel</a>
</form>

panelapp/panels/templates/panels/entity/review/part_phenotypes.html
{% load bootstrap3 %}
<div class="js-toggle-target">
    {{ entity.phenotypes|join:"; " }}
    <a href="#" class="add-left-margin link-inherit js-toggle">Edit</a>
</div>
<form data-ajax-action="{% url 'panels:update_entity_phenotypes' panel.panel_id entity_type entity_name %}" action="{% url 'panels:update_entity_phenotypes' panel.panel_id entity_type entity_name %}#!review" method="post" class="form js-toggle-target hide">
    {% csrf_token %}
    {% for field in edit_entity_phenotypes_form %}
      {{ field.label_tag }}
      <div class="add-label-margin">{% bootstrap_field field show_label=False %}</div>
      <span class="rm">{{ field.label_tag }}</span>
    {% endfor %}
    <input type="submit" class="btn btn-info" value="Save phenotypes">
    <a href="#" class="add-left-margin btn btn-link js-toggle">Cancel</a>
</form>

panelapp/panels/templates/panels/entity/review/part_publications.html
{% load bootstrap3 %}
{% load panel_helpers %}
<div class="js-toggle-target">
    {% if entity.publications %}
    <ul>
      {% for publication in entity.publications %}
        <li>{{ publication|pubmed_link|join:'' }}</li>
      {% endfor %}
    </ul>
    {% endif %}
    <a href="#" class="add-left-margin link-inherit js-toggle">Edit</a>
</div>
<form data-ajax-action="{% url 'panels:update_entity_publications' panel.panel_id entity_type entity_name %}" action="{% url 'panels:update_entity_publications' panel.panel_id entity_type entity_name %}#!review" method="post" class="form js-toggle-target hide">
    {% csrf_token %}
    {% for field in edit_entity_publications_form %}
      {{ field.label_tag }}
      <div class="add-label-margin">{% bootstrap_field field show_label=False %}</div>
      <span class="rm">{{ field.label_tag }}</span>
    {% endfor %}
    <input type="submit" class="btn btn-info" value="Save publications">
    <a href="#" class="add-left-margin btn btn-link js-toggle">Cancel</a>
</form>

panelapp/panels/templates/panels/entity/review/part_rating.html
{% load bootstrap3 %}
{% load panel_helpers %}
<div class="js-toggle-target">
  <span class="gel-banner {{ entity|gene_list_class }}">{{ entity|gene_list_name }}</span>
  <a href="#" class="add-left-margin link-inherit js-toggle">Edit</a>
</div>
<form data-ajax-action="{% url 'panels:update_entity_rating' panel.panel_id entity_type entity_name %}" action="{% url 'panels:update_entity_rating' panel.panel_id entity_type entity_name %}#!review" method="post" class="form hide js-toggle-target">
    {% csrf_token %}
    {% for field in edit_entity_rating_form %}
      {{ field.label_tag }}
      <div class="add-label-margin">{% bootstrap_field field show_label=False %}</div>
      <span class="rm">{{ field.label_tag }}</span>
    {% endfor %}
    <input type="submit" class="btn btn-info" value="Update">
    <a href="#" class="add-left-margin btn btn-link js-toggle">Cancel</a>
</form>

panelapp/panels/templates/panels/entity/review/part_tags.html
{% load bootstrap3 %}
<h4 class="add-bottom-margin">Tags</h4>
<div class="panel panel-default review-table" data-module="ajax-form">
  <form data-module="tag-input" data-ajax-action="{% url 'panels:update_entity_tags' panel.panel_id entity_type entity_name %}" action="{% url 'panels:update_entity_tags' panel.panel_id entity_type entity_name %}#!review" method="post" class="form panel-body">
    {% csrf_token %}
    {% for field in edit_entity_tags_form %}
      <span class="rm">{{ field.label_tag }}</span>
      {% bootstrap_field field show_label=False %}
    {% endfor %}
    {% if updated %}
      <p class="text-muted js-tag-saved-status" style="margin-top: 5px">Saved at {{ updated }}</p>
    {% endif %}
    <input type="submit" class="btn btn-info add-top-margin" value="Save changes">
  </form>
</div>

panelapp/panels/templates/panels/entity/review/review_evaluations.html
{% for comment in entity.get_review_comments %}
  <blockquote class="add-top-margin">
    {{ comment.comment }}
    <h6>{{ comment.user.get_reviewer_name }}, {{ comment.created|date }}</h6>
    {% if request.user == comment.user and panel and entity %}
      <a href="{% url "panels:delete_comment_by_user" panel.panel_id entity_type entity_name comment.pk %}" class="btn btn-default btn-xs" data-ajax="true" data-success="djangoAjaxHandler">Delete comment</a>
    {% endif %}
  </blockquote>
{% endfor %}